<?php
/**
*
* @package Topic SiteMap php code
* @version 1.0.0 of 07.04.2009
* @copyright (c) By Shapoval Andrey Vladimirovich (AllCity) ~ http://allcity.net.ru/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

// Custom Page code from http://www.phpbb.com/kb/article/add-a-new-custom-page-to-phpbb/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path.'common.'.$phpEx);

// Start session management code from http://www.phpbb.com/kb/article/add-a-new-custom-page-to-phpbb/
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Cache function
function Topic_SiteMap_SQL()
{
  global $db, $cache;

  // Here you can set the default time to reload cache in days (from 1 to 7 recommend)
  $cache_time_limit = 7;

    // Try finding the data in the cacge
    if(($sitemap_sql_data = $cache->get('_topic_sitemap_sql')) === false)
    {

      $sitemap_sql = array(
      'SELECT' => 't.topic_id, t.forum_id, t.topic_last_post_time, t.topic_type, t.topic_replies',
      'FROM' => array(TOPICS_TABLE => 't'),
      'ORDER_BY' => 't.topic_type DESC'
      );
      /* Disabled for Topic pages function ***************************************************
      // Limit URL 50,000 max http://www.sitemaps.org/protocol.php#index
      $result = $db->sql_query_limit($db->sql_build_query('SELECT', $sitemap_sql), 50000);
      ***************************************************************************************/
      $result = $db->sql_query($db->sql_build_query('SELECT', $sitemap_sql));
      while($row = $db->sql_fetchrow($result))
      {
        $sitemap_sql_data[] = array(
        'topic_id' => $row['topic_id'],
        'forum_id' => $row['forum_id'],
        'topic_last_post_time' => $row['topic_last_post_time'],
        'topic_type' => $row['topic_type'],
        'topic_replies' => $row['topic_replies']
        );
      }
      $db->sql_freeresult($result);

    // cache this data, this improves performance!
    $cache->put('_topic_sitemap_sql', $sitemap_sql_data, 86400*$cache_time_limit);
    }

  // Return data
  return $sitemap_sql_data;
}

// Data function
function Topic_SiteMap_DATA()
{
  global $phpEx, $config;

    $sql_cache = Topic_SiteMap_SQL();

      foreach($sql_cache as $row)
      {
          // Topic priority
          switch ($row['topic_type'])
          {
            case 0:
              // Post topic as normal
              $sitemap_priority = 0.5;
            break;
            case 1:
              // Post topic as sticky
              $sitemap_priority = 0.6;
            break;
            case 2:
              // Post topic as announce
              $sitemap_priority = 0.7;
            break;
            case 3:
              // Post topic as global
              $sitemap_priority = 0.8;
            break;
          }
        // Topic pages
        $sitemap_pages = (int) $row['topic_replies']/$config['posts_per_page'];
        for($i=0; $i<=$sitemap_pages; $i++)
        {
          if ($i == 0)
          {
            $page_url = generate_board_url()."/viewtopic.".$phpEx."?f=".$row['forum_id']."&amp;t=".$row['topic_id'];
          }
            else
          {
            $page_url = generate_board_url()."/viewtopic.".$phpEx."?f=".$row['forum_id']."&amp;t=".$row['topic_id']."&amp;start=".$i*$config['posts_per_page'];
          }
        echo "<url>\r\n";
        echo "<loc>".$page_url."</loc>\r\n";
        // lastmod in ISO 8601 format
        echo "<lastmod>".date('Y-m-d\TH:i:s+00:00',$row['topic_last_post_time'])."</lastmod>\r\n";
        echo "<changefreq>weekly</changefreq>\r\n";
        echo "<priority>".$sitemap_priority."</priority>\r\n";
        echo "</url>\r\n";
        }
      }

  // Return function
  return true;
}

// This xml file content!
header("Content-Type: text/xml");

// SiteMap header...
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"\x3F>\r\n";
echo "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\r\n";

// SiteMap body...
Topic_SiteMap_DATA();

// SiteMap footer...
echo "</urlset>";

?>